/*
    MakeMKV GUI - Graphics user interface application for MakeMKV

    Copyright (C) 2009-2010 GuinpinSoft inc <makemkvgui@makemkv.com>

    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/

    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

*/
#include <stdint.h>
#include <unistd.h>
#include <sys/types.h>

#include <mach/mach.h>

#import <servers/bootstrap.h>
#import <Foundation/Foundation.h>
#import <CoreServices/CoreServices.h>

mach_port_t MacBootstrapGetPort(const char* name)
{
    int nserr;

    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];

    NSString *ns_port_name = [NSString stringWithUTF8String:name];

    NSMachPort* nsport = (NSMachPort*) [[NSMachBootstrapServer sharedInstance] portForName:ns_port_name];

    if (nil==nsport) return MACH_PORT_NULL;

    mach_port_t port = [nsport machPort];

    if (port != MACH_PORT_NULL)
    {
        if (mach_port_insert_right(mach_task_self(),port,port,MACH_MSG_TYPE_COPY_SEND)!=KERN_SUCCESS)
        {
            return MACH_PORT_NULL;
        }
    }

    [nsport release];

    [pool release];

    return port;
}

