/*
    MakeMKV GUI - Graphics user interface application for MakeMKV

    Copyright (C) 2009-2010 GuinpinSoft inc <makemkvgui@makemkv.com>

    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/

    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

*/
#import <Foundation/Foundation.h>
#import <Growl/Growl.h>

class QMainWindow;

#include <QtCore/QString.h>
#include "notify.h"

void notifyInit()
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];

    [GrowlApplicationBridge registerWithDictionary:nil];

    [pool release];
}

void notifyStart(QMainWindow* mainWindow,unsigned long Id,const QString &Name)
{
}

void notifyUpdate(QMainWindow* mainWindow,unsigned int Value,unsigned int MaxValue,unsigned int TimeElapsed)
{
}

void notifyFinish(QMainWindow* mainWindow)
{
}

void notifyEvent(QMainWindow* mainWindow,unsigned long Id,const char* IdName,const QString &Text,const QString &Name)
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];

    QByteArray  dataText = Text.toUtf8();
    NSString* stringName = [[NSString alloc] initWithUTF8String: IdName];
    NSString* stringText = [[NSString alloc] initWithUTF8String: dataText.data() ];

    [GrowlApplicationBridge notifyWithTitle:@"MakeMKV"
       description:stringText
       notificationName:stringName
       iconData:nil
       priority:0
       isSticky:NO
       clickContext:nil];

    [stringName release];
    [stringText release];
    [pool release];
}

void notifyCleanup()
{
}

