/*
    MakeMKV GUI - Graphics user interface application for MakeMKV

    Copyright (C) 2009-2010 GuinpinSoft inc <makemkvgui@makemkv.com>

    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/

    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

*/
#include <lgpl/aproxy.h>
#include <lgpl/smem.h>
#include <lgpl/sstring.h>
#include <stdint.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>

#include <mach/mach.h>
#include <mach/message.h>

mach_port_t MacBootstrapGetPort(const char* name);

bool ApOpenSgrp(AP_SGRP *sgrp,const uint64_t* data)
{
    mach_port_t port[2];

    for (unsigned int i=0;i<2;i++)
    {
        port[i] = MacBootstrapGetPort( ((const char*)data) + data[i]);
        if (port==MACH_PORT_NULL) return false;
    }
    sgrp->a_id = port[0];
    sgrp->b_id = port[1];

    return true;
}

bool ApSemInc(AP_SGRP *sgrp,uintptr_t sid)
{
    kern_return_t kerr;

    kerr = semaphore_signal((semaphore_t)sid);

    return(kerr==KERN_SUCCESS);
}

bool ApSemDec(AP_SGRP *sgrp,uintptr_t sid)
{
    mach_timespec_t tm;
    kern_return_t kerr;

    tm.tv_sec = AP_SEM_TIMEOUT;
    tm.tv_nsec = 0;

    kerr = semaphore_timedwait((semaphore_t)sid,tm);

    return(kerr==KERN_SUCCESS);
}

